<?php 
class NiceSSH { 
       
    private $ssh_host = 'myserver.example.com';  // SSH Host 
    private $ssh_port = 22;  // SSH Port 
    private $ssh_server_fp = 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx';      // SSH Server Fingerprint 
    private $ssh_auth_user = 'username';  // SSH Username 
    private $ssh_auth_pub = '/home/username/.ssh/id_rsa.pub';      // SSH Public Key File 
    private $ssh_auth_priv = '/home/username/.ssh/id_rsa';  // SSH Private Key File 
    private $ssh_auth_pass;      // SSH Private Key Passphrase (null == no passphrase) 
    private $connection;      // SSH Connection 
    
    public function connect() { 
		$result=true;
        if (!($this->connection = ssh2_connect($this->ssh_host, $this->ssh_port))) { 
            throw new Exception('Cannot connect to server'); 
			$result=false;
        } 
        $fingerprint = ssh2_fingerprint($this->connection, SSH2_FINGERPRINT_MD5 | SSH2_FINGERPRINT_HEX); 
        if (strcmp($this->ssh_server_fp, $fingerprint) !== 0) { 
            throw new Exception('Unable to verify server identity!'); 
			$result=false;
        } 
        if (!ssh2_auth_pubkey_file($this->connection, $this->ssh_auth_user, $this->ssh_auth_pub, $this->ssh_auth_priv, $this->ssh_auth_pass)) { 
            throw new Exception('Autentication rejected by server'); 
			$result=false;
        } 
		 
		return $result;
    } 
    public function exec($cmd) { 
        if (!($stream = ssh2_exec($this->connection, $cmd))) { 
            throw new Exception('SSH command failed'); 
        } 
        stream_set_blocking($stream, true); 
        $data = ""; 
        while ($buf = fread($stream, 4096)) { 
            $data .= $buf; 
        } 
        fclose($stream); 
        return $data; 
    } 
    public function disconnect() { 
        $this->exec('echo "EXITING" && exit;'); 
        $this->connection = null; 
    } 
    public function __destruct() { 
        $this->disconnect(); 
    } 
} 
?> 